#!/usr/bin/perl -w
# skript pro komentovani pam konfiguracnich souboru
# v souborech jsou sekce oznacene '### BEGIN:...' a '### END:...'
# kde ... je jmeno baliku ke kteremu sekce prislusi
# 
# pouziti pamconfig.pl <soubor> <zap/vyp> <sekce>
# vystup jde na STDOUT
# bodik@students.zcu.cz 2003

#dopredna deklarace 
sub zmena;
sub napoveda;

# promena do ktere se cte soubor (po radcich)
my $line;

## zpracovani prikazove radky :))
if(!defined($ARGV[2])) {
        print "Malo parametru !!\n";
        napoveda;
        exit(1);
}

# jmeno zpracovavaneho souboru
my $file = $ARGV[0];

# typ akce ktera se bude provadet [zap/vyp]
my $action = $ARGV[1]; 
if( ! (($action eq "zap") || ($action eq "vyp")) ) {
        print "Chybne zadane parametry !!\n";
        napoveda;
        exit(1);
}

#zde bude hledany retezec 
my $tofind = "### BEGIN:".uc($ARGV[2]); # sekce
###print "debug: $tofind\n";

open(FR, $file) or die "Nemuzu otevrit soubor $file";
##open(FW, $nfile) or die "Nemuzu otevrit vystupni soubor $nfile";

# cte dokud nenarazi na specialni radku oznacujici 
# zacatek hledaneho bloku
while($line = <FR>) {
        if($line =~ /^$tofind.*/) {
                print $line; # tiskne nalezenou oddelovaci radku
                zmena;
         } else {
                print $line; # tohle tiskne radky mezi bloky
        }
}

# v hledanem bloku zapne/vypne komentare
sub zmena {
  my $line;
  
  #zamenim hledany retezec (tak se vyhnu pripadnemu prolinani sekci !!)
  $tofind =~ s/BEGIN/END/;
  while($line = <FR>) {
        if( $line =~ /^$tofind.*/ ) {
                
                # jestli ze to je ukoncovaci radka bloku
                # vytisknu a vratim se zpatky mimo blok
                print $line;
                $tofind =~ s/END/BEGIN/;
                return; 
        } else {
        
                # podle $action vypnu nebo zapnu komentare
                if($action eq "zap") {
                        $line =~ m/^(#*)(.*)/;
                        print "$2\n";
                } elsif ($action eq "vyp") {
                        print "#".$line;
                }
        } 
  }
}

sub napoveda {
        print "Program: pamconfig.pl [vstupni soubor] [zap/vyp] [sekce]\n";
        print "skript pro komentovani pam konfiguracnich souboru\n";
        print "Autor: bodik <bodik\@students.zcu.cz>; pro CIV roku 2003\n\n";
        print "zap/vyp .. zapne nebo vypne sekci\n";
        print "sekce .. oznaceni sekce se kterou se manipuluje. Momentalne podporovane sekce:\n";
        print "\t KRB5ORION, SSHKRB5ORION, OPENAFSORION, LDAPORION\n";
        print "\n";
        
        return;        
}

